Subject: Re: 2292bis IPV6_PKTINFO and IPv4-mapped IPv6 Addresses

From: Tim Hartrick <[email-masked]>
Date: Tue, 17 Aug 1999 18:08:30 -0700 (PDT)

Bob,

> 
> I propose that either:
> 
>     Support of IPV6_PKTINFO for IPv4-mapped IPv6 addresses be made
>     mandatory
> 
> or
> 
>     Applications be given an easy way of determining (at compile time or
>     run time) whether a given implementation supports IPV6_PKTINFO for
>     IPv4-mapped IPv6 addresses
> 
> I prefer the former, but realize that it may be too much of a burden to
> make mandatory.  If support is not going to be mandatory, we need a
> definite way of knowing whether support is available.
>

From a implementation complexity point of view I would prefer a third
alternative which is that we simply don't support IPV6_PKTINFO option for
mapped addresses.  No may about it.

I agree that the may is bad so we probably shouldn't fence sit.  It is
either supported or it is not.

I would think that your second alternative above would be no good at all
since you still have to test and maintain the old code for handling multiple
file descriptors and interface scanning.  Maybe you need to do that any-
way so it is not big deal.

It would be nice if you could simply depend on the existence of IP_RECVDSTADDR
and something like what we call IP_RECVIFADDR.  Oh well.....
 
> Also, in section 11 the draft says:
> 
>     In general, attempting to specify an IPv6-only option, such as the
>     Hop-by-Hop options, Destination options, or Routing header on an IPv6
>     socket that is using IPv4-mapped IPv6 addresses, will probably result
>     in an error.
> 
> One interpretation of the text above would be that an implementation
> may silently ignore the option.  I propose "will result in an error"
> instead of "will probably result in an error".
> 

I am with you.  We fail any option which does not match the network layer
of the socket.  That is you can't set IP_TTL on an AF_INET6 socket and you
can't set IPV6_HOPLIMIT on an AF_INET socket.

tim
--------------------------------------------------------------------
IETF IPng Working Group Mailing List
IPng Home Page:                      http://playground.sun.com/ipng
FTP archive:                      ftp://playground.sun.com/pub/ipng
Direct all administrative requests to [email-masked]
--------------------------------------------------------------------